--
-- modified Testbench from webpage documentation
--
--

     --  A testbench has no ports.
     entity adder_tb is
     end adder_tb;

     architecture behav of adder_tb is

        --  Declaration of the components that will be instantiated.
        component adder
          port (i0, i1 : in bit; ci : in bit; s : out bit; co : out bit);
        end component;

        component hello_world
        end component;

        component led_dhr
          port (led1 : in bit; led2 : in bit;       led_out  : out bit );
        end component;

	component dff
          port (clk  : in  bit;
               din  : in  bit;
               dout : out bit);
        end component;


        --  Specifies which entity is bound with the component.
        for adder_0: 		adder use entity work.adder;

        for hello_world_0: 	hello_world use entity work.hello_world;

        for led_dhr_0: 		led_dhr use entity work.led_dhr;

        for dff_0: 		dff use entity work.dff;


--
-- named interconnect wires.
--

--        signal wire_i0, wire_i1, wire_ci, wire_s, wire_co,      wire_led1, wire_led2, wire_led_out : bit;
     signal wire_i0, wire_i1, wire_ci, wire_s, wire_co,       wire_led_out ,wire_led_out2 : bit;



     begin
        --  Component instantiation.
        adder_0: adder port map (i0 => wire_i0, i1 => wire_i1, ci => wire_ci,
                                 s => wire_s, co => wire_co);

        hello_world_0: hello_world ;

				    -- connect pin  to signal
	led_dhr_0: led_dhr port map (led1 => wire_i0, led2 => wire_i1,
                                    led_out => wire_led_out     );

	dff_0: dff port map (
	  clk  => wire_ci,
          din  => wire_i1,
          dout => wire_led_out2 );

        --  This process does the real job.
        process
           type pattern_type is record
              --  The inputs of the adder.
              i0, i1, ci : bit;
              --  The expected outputs of the adder.
              s, co : bit;
           end record;
           --  The patterns to apply.
           type pattern_array is array (natural range <>) of pattern_type;
           constant patterns : pattern_array :=

             (--i0, i1,  ci,   s  , co
			  ('0', '0', '0',  '0', '0'),
              ('0', '0', '1',  '1', '0'),
              ('0', '1', '0',  '1', '0'),

--              ('0', '1', '0',  '1', '1'), --  error

              ('0', '1', '1',  '0', '1'),
              ('1', '0', '0',  '1', '0'),
              ('1', '0', '1',  '0', '1'),
              ('1', '1', '0',  '0', '1'),
              ('1', '1', '1',  '1', '1'));
        begin
           --  Check each pattern.

           for i in patterns'range loop
              --  Set the inputs.
              wire_i0 <= patterns(i).i0;
              wire_i1 <= patterns(i).i1;
              wire_ci <= patterns(i).ci;
              --  Wait for the results.
              wait for 10 ns;
              --  Check the outputs.
              assert wire_s = patterns(i).s
                 report "bad sum value" severity error;
              assert wire_co = patterns(i).co
                 report "bad carray out value" severity error;
           end loop;
           assert false report "end of test" severity note;
           --  Wait forever; this will finish the simulation.
           wait;
        end process;
     end behav;

