--
-- doug.vhdl is a more complex bit of logic
--
--
--




--
--
-- define some sub modules to connect together
--

--
-- minimal logic
--

ENTITY doug_ip is
       port (i0, i1 : in bit;  clk : in bit ; out1 , out2 : out bit );
 end doug_ip ;

ARCHITECTURE rtl of doug_ip is
 begin
     p1:process(clk)
         begin
             if  CLK'event and CLK='1' then
			 out1 <= i1 ;
             end if;
     end process;
	 out2 <= i0;
 end rtl ;


--
-- minimal logic
--


ENTITY doug_middle is
       port (i0, i1 : in bit;  clk : in bit ; out1 , out2 : out bit );
 end doug_middle ;

ARCHITECTURE rtl of doug_middle is
 begin
     p1:process(clk)
         begin
             if  CLK'event and CLK='1' then
			 out1 <= i1 ;
             end if;
     end process;
	 out2 <= i0;
 end rtl ;


--
-- minimal logic
--


ENTITY doug_op is
       port (i0, i1 : in bit;  clk : in bit ; out1 , out2 : out bit );
 end doug_op ;

ARCHITECTURE rtl of doug_op is
 begin
     p1:process(clk)
         begin
             if  CLK'event and CLK='1' then
			 out1 <= i1 ;
             end if;
     end process;
	 out2 <= i0;
 end rtl ;



--
-- doug_board
--

ENTITY doug_board is
       port (i0, i1 : in bit;  clk : in  bit ;
	   out1 ,out2 				   : out bit

	   );
 end doug_board ;



--ARCHITECTURE rtl of doug_board is
architecture structure  of doug_board is

  signal middle_ip , out1a, out1b, out1c, op_ip	: bit;


  component
    doug_ip
       port (i0, i1 : in bit;  clk : in bit ; out1 , out2 : out bit );
  end component;

  component
    doug_middle
       port (i0, i1 : in bit;  clk : in bit ; out1 , out2 : out bit );
  end component;
  component
    doug_op
       port (i0, i1 : in bit;  clk : in bit ; out1 , out2 : out bit );
  end component;


  begin
   doug_b_ip: doug_ip
 	   port map(         i0, i1,    clk ,   out1a , middle_ip  );

   doug_b_middle: doug_middle
       port map(  middle_ip, out1a, clk ,   out1b , op_ip  );

   doug_b_op: doug_op
       port map(      op_ip, out1b, clk ,   out1c ,   out2  );

 end structure;


--architecture structure of latch is
--  component nor_gate
--    port (a,b: in bit;
--	  c: out bit);
--  end component;
--begin
--  n1: nor_gate
--    port map (r,nq,q);
--  n2: nor_gate
--    port map (s,q,nq);
--end structure;

ENTITY dff is
     port(clk  : in  bit;
          din  : in  bit;
          dout : out bit);
 end dff;

ARCHITECTURE rtl of dff is
 begin
     p1:process(clk)
         begin
             if  CLK'event and CLK='1' then
                 dout <= din;
             end if;
     end process;
 end rtl;


 --http://www.gmvhdl.com/connect.htm

-- entity latch is
--  port (s,r: in bit;
--	q,nq: out bit);
--end latch;

-- We can specify the same connections that occur in the schematic using VHDL with the following architecture declaration:

-- architecture structure  of latch is
--  component nor_gate
--    port ( a, b: in bit;
--	  c: out bit);
--  end component;
--begin
--  n1: nor_gate
--    port map (r,nq,q);
--  n2: nor_gate
--    port map (s,q,nq);
--end structure;


--We might build an entity like the one that follows.
--entity latch is
--  port (s,r : in bit;
--        q,nq : out bit);
--end latch;

--architecture dataflow of latch is
--begin
--  q<=r nor nq;
--  nq<=s nor q;
--end dataflow;
